petsc-3.12.1 2019-10-22
Report Typos and Errors

# VecGetArrayRead

Get read-only pointer to contiguous array containing this processor's portion of the vector data.

### Synopsis

    #include "petscvec.h"
    PetscErrorCode VecGetArrayRead(Vec x,const PetscScalar **a)

Not Collective

### Input Parameters

x -the vector

### Output Parameter

a -the array

### Notes

The array must be returned using a matching call to VecRestoreArrayRead().

Unlike VecGetArray(), this routine is not collective and preserves cached information like vector norms.

Standard PETSc vectors use contiguous storage so that this routine does not perform a copy. Other vector implementations may require a copy, but must such implementations should cache the contiguous representation so that only one copy is performed when this routine is called multiple times in sequence.

### See Also

VecGetArray(), VecRestoreArray(), VecGetArrayPair(), VecRestoreArrayPair()

### Level

beginner

### Location

src/vec/vec/interface/rvector.c

### Examples

src/vec/vec/examples/tutorials/ex10.c.html
src/vec/is/sf/examples/tutorials/ex2.c.html
src/mat/examples/tutorials/ex12.c.html
src/dm/examples/tutorials/swarm_ex3.c.html
src/dm/field/examples/tutorials/ex1.c.html
src/ksp/ksp/examples/tutorials/ex10.c.html
src/ksp/ksp/examples/tutorials/ex70.c.html
src/ksp/ksp/examples/tutorials/ex73.c.html
src/snes/examples/tutorials/ex1.c.html
src/snes/examples/tutorials/ex2.c.html
src/snes/examples/tutorials/ex42.c.html

### Implementations

VecGetArrayRead_Node in src/vec/vec/impls/node/vecnode.c
Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages